// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _FOOCANVASMM_ITEM_H
#define _FOOCANVASMM_ITEM_H

#include <glibmm.h>

// -*- C++ -*-
/* $Id: item.hg,v 1.2 2004/06/09 20:20:16 cactus Exp $ */

/* item.h
 * 
 * Copyright (C) 1998 EMC Capital Management Inc.
 * Developed by Havoc Pennington <hp@pobox.com>
 *
 * Copyright (C) 1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/object.h>
#include <gdkmm/cursor.h>
#include <libfoocanvas/foo-canvas.h>

#include <foocanvasmm/point.h>
#include <foocanvasmm/properties.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _FooCanvasItem FooCanvasItem;
typedef struct _FooCanvasItemClass FooCanvasItemClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace FooCanvasmm
{ class Item_Class; } // namespace FooCanvasmm
namespace FooCanvasmm
{

class Canvas;
class Group;


class Item : public Gtk::Object
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Item CppObjectType;
  typedef Item_Class CppClassType;
  typedef FooCanvasItem BaseObjectType;
  typedef FooCanvasItemClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~Item();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class Item_Class;
  static CppClassType item_class_;

  // noncopyable
  Item(const Item&);
  Item& operator=(const Item&);

protected:
  explicit Item(const Glib::ConstructParams& construct_params);
  explicit Item(FooCanvasItem* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  FooCanvasItem*       gobj()       { return reinterpret_cast<FooCanvasItem*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const FooCanvasItem* gobj() const { return reinterpret_cast<FooCanvasItem*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual bool on_event(GdkEvent* p1);


private:

  
public:

  //:  Move an item by the specified amount
  
  void move(double dx, double dy);

  //: Raise an item in the z-order of its parent group by the specified
  //: number of positions.  If the number is zero, then the item will
  //: be made the topmost of its parent group.
  
  void raise(int positions);

  //: Lower an item in the z-order of its parent group by the specified
  //: number of positions.  If the number is zero, then the item will be
  //: made the bottommost of its parent group.  */
  
  void lower(int positions);

  //: Raise an item to the top of its parent group's z-order.
  
  void raise_to_top();

  //: Lower an item to the bottom of its parent group's z-order
  
  void lower_to_bottom();

  //: Grab the mouse for the specified item.  Only the events in
  //: event_mask will be reported.  If cursor is non-NULL, it will be
  //: used during the duration of the grab.  Time is a proper X event
  //: time parameter.  Returns the same values as XGrabPointer().
  int grab(unsigned int event_mask, const Gdk::Cursor& cursor, guint32 etime);
  int grab(unsigned int event_mask, guint32 etime);
  

  //: Ungrabs the mouse -- the specified item must be the same that was
  //: passed to foo_canvas_item_grab().  Time is a proper X event
  //: time parameter. 
  
  void ungrab(guint32 etime);

  //: These functions convert from a coordinate system to another.  "w"
  //: is world coordinates and "i" is item coordinates. 
  
  void w2i(double& x, double& y);
  
  void i2w(double& x, double& y);

  //: Used to send all of the keystroke events to a specific item as well 
  //: as GDK_FOCUS_CHANGE events.
  
  void grab_focus();

  //: Fetch the bounding box of the item.  The bounding box may not be 
  //: exactly tight, but the canvas items will do the best they can.
  
  void get_bounds(double& x1, double& y1, double& x2, double& y2) const;

  //: Make the item visible
  
  void show();
  
  //: Hide the item
  
  void hide();

  
  void reparent(Group& new_group);

  /// Returns the canvas we're on.
  Canvas* get_canvas() const;

    virtual void update_vfunc(double i2w_dx, double i2w_dy, int flags);
    virtual void realize_vfunc();
    virtual void unrealize_vfunc();
    virtual void map_vfunc();
    virtual void unmap_vfunc();
    virtual void draw_vfunc(GdkDrawable* drawable, GdkEventExpose * expose);
    virtual double point_vfunc(double x, double y, int cx, int cy, FooCanvasItem** actual_item);
    virtual void bounds_vfunc(double* x1, double* y1, double* x2, double* y2);

  //: Signal: an event ocurred for an item of this type.  The(x, y)
  //: coordinates are in the canvas world coordinate system.
  

  Glib::SignalProxy1< bool,GdkEvent* > signal_event();


  /** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Group*> property_parent() ;

/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Group*> property_parent() const;


protected:

  //- For class children use only
  void item_construct(Group& group);

  //- Unsafe version - can't use a _gtk_string here, C++ doesn't like
  //- classes being passed before ellipses('...') args
  void item_construct(Group& group, const gchar* first_arg_name,
                      va_list ap);

  //- Set arguments - For class children use only
  void set(const gchar* first_arg_name, ...);

  //: Request that the update method eventually get called.  This should be used
  //: only by item implementations.
  
  void request_update();
  
  void request_redraw();


  void reset_bounds();
  
  void update_bbox(int x1, int y1, int x2, int y2);
  

};

} /* namespace FooCanvasmm */

namespace Glib
{
  /** @relates FooCanvasmm::Item
   * @param object The C instance
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   */
  FooCanvasmm::Item* wrap(FooCanvasItem* object, bool take_copy = false);
}
#endif /* _FOOCANVASMM_ITEM_H */

